/* This program estimates pi using simulation. It generates points and counts the hits
 * inside a circle and compares it to the total hits inside the surrounding square.  */
#include <stdio.h>
#include <stdlib.h>

int main()
{
	long i, countAs=0, countAc=0;
	double x, y;

	srand(23); // Used to initialize the random number generator
	for(i = 0; i < 1000000; i++)
	{
		// rand() generates a random integer from 0 to RAND_MAX=32767
		// generate random number between -1 and 1
		x = -1 + 2 * ((double)rand()) / RAND_MAX;

		// generate random number between -1 and 1
		y = -1 + 2 * ((double)rand()) / RAND_MAX;

		// check if it is in the circle
		if (x*x + y*y <= 1.0)
			countAc++;
		// it must be in the square, why?
		countAs++;
	}
	printf("The estimation of pi is: %g\n", (4.0 * countAc) / countAs);
	return 0;
}